{-- TerraHS - Interface between TerraLib and Haskell

    (c) Sergio Costa (INPE) - Setembro, 2005

	This program is free software; you can redistribute it 
    and/or modify it under the terms of the GNU General 
    Public License 2.1 as published by the Free Software Foundation
    (http://www.opensource.org/licenses/gpl-license.php)
--}

{--  --}

module TerraHS.TerraLib
	(
	TeDatabase(..),
	TeDatabases (..),

	-- Geometry.hs
	TeGeometry(..), TePoint(..), TePolygon(..), TeLine2D(..), TeCell(..), TeBox(..),
	TePointSet(..) ,TePolygonSet(..) ,TeLineSet(..),TeCellSet(..), 
	
	-- STInstance.hs	
	TeSTInstance (..),
	
	loadRasterFile,

	-- GeometyAlgorithms
	Topology (..), Overlay (..),
	
	)
	 where 

	 
import TerraHS.Misc.Object
import TerraHS.Misc.Generic

import TerraHS.TerraLib.TeGeometry
import TerraHS.TerraLib.TePoint
import TerraHS.TerraLib.TeLine2D
import TerraHS.TerraLib.TeCell
import TerraHS.TerraLib.TeBox
import TerraHS.TerraLib.TePolygon

import TerraHS.TerraLib.TeGeometryAlgorithms
import TerraHS.TerraLib.TeOverlay
import TerraHS.TerraLib.TeTopologyOps
import TerraHS.TerraLib.TeSTInstance
import TerraHS.TerraLib.TeLayer
import TerraHS.TerraLib.TeRaster
import TerraHS.TerraLib.TeQuerier
import TerraHS.TerraLib.TeDatabase




	
	
	



